REM $DYNAMIC
DEFINT A-Z
DECLARE SUB setmouserange (x%, y%, X2%, Y2%)
DECLARE SUB defaultmouse ()
DECLARE SUB mousestatus (lb, rb, x, y)
DECLARE SUB mouseput (x%, y%)
DECLARE SUB mouseshow ()
DECLARE SUB mousehide ()
DECLARE SUB resetmouserange ()
DECLARE SUB textcursor ()
TYPE RegTypeX
	 AX    AS INTEGER
	 bx    AS INTEGER
	 cx    AS INTEGER
	 dx    AS INTEGER
	 bp    AS INTEGER
	 si    AS INTEGER
	 di    AS INTEGER
	 flags AS INTEGER
	 ds    AS INTEGER
	 es    AS INTEGER
END TYPE
DIM SHARED row, col, height, length AS INTEGER
COMMON SHARED REGS AS RegTypeX
SCREEN 12
LINE (0, 0)-(640, 480), 3, BF
defaultmouse
'textcursor
setmouserange 0, 0, 638, 478
mouseput 300, 225
mouseshow
DO
mousestatus lb, rb, x, y
SELECT CASE INKEY$
'CASE "": GOTO 23
CASE CHR$(27): GOTO 1234
CASE "4": mouseput x - 10, y
CASE "6": mouseput x + 10, y
CASE "8": mouseput x, y - 10
CASE "2": mouseput x, y + 10
END SELECT
23
LOOP UNTIL INKEY$ = CHR$(27)
1234
mousehide
CLS
SCREEN 0: WIDTH 80
SYSTEM

REM $STATIC
SUB defaultmouse
' Makes a screen and cursor mask and changes the mousecursor with a BIOS call

DIM CURSOR%(0 TO 15, 0 TO 1)
'   SCREEN MASK
	CURSOR%(0, 0) = &H3FFF           '0011111111111111
	CURSOR%(1, 0) = &H1FFF           '0001111111111111
	CURSOR%(2, 0) = &HFFF            '0000111111111111
	CURSOR%(3, 0) = &H7FF            '0000011111111111
	CURSOR%(4, 0) = &H3FF            '0000001111111111
	CURSOR%(5, 0) = &H1FF            '0000000111111111
	CURSOR%(6, 0) = &HFF             '0000000011111111
	CURSOR%(7, 0) = &H7F             '0000000001111111
	CURSOR%(8, 0) = &H3F             '0000000000111111
	CURSOR%(9, 0) = &H1F             '0000000000011111
	CURSOR%(10, 0) = &H1FF           '0000000111111111
	CURSOR%(11, 0) = &H10FF          '0001000011111111
	CURSOR%(12, 0) = &H30FF          '0011000011111111
	CURSOR%(13, 0) = &HF87F          '1111100001111111
	CURSOR%(14, 0) = &HF87F          '1111100001111111
	CURSOR%(15, 0) = &HFC7F          '1111110001111111

	' Define the cursor% mask
	  CURSOR%(0, 1) = &H0            '0000000000000000
	  CURSOR%(1, 1) = &H4000         '0100000000000000
	  CURSOR%(2, 1) = &H6000         '0110000000000000
	  CURSOR%(3, 1) = &H7000         '0111000000000000
	  CURSOR%(4, 1) = &H7800         '0111100000000000
	  CURSOR%(5, 1) = &H7C00         '0111110000000000
	  CURSOR%(6, 1) = &H7E00         '0111111000000000
	  CURSOR%(7, 1) = &H7F00         '0111111100000000
	  CURSOR%(8, 1) = &H7F80         '0111111110000000
	  CURSOR%(9, 1) = &H7C00         '0111110000000000
	  CURSOR%(10, 1) = &H6C00        '0110110000000000
	  CURSOR%(11, 1) = &H4600        '0100011000000000
	  CURSOR%(12, 1) = &H600         '0000011000000000
	  CURSOR%(13, 1) = &H300         '0000001100000000
	  CURSOR%(14, 1) = &H300         '0000001100000000
	  CURSOR%(15, 1) = &H0           '0000000000000000

REGS.AX = &H9
REGS.bx = 0
REGS.cx = 0
REGS.es = VARSEG(CURSOR%(0, 0))
REGS.dx = VARPTR(CURSOR%(0, 0))
CALL INTERRUPTX(&H33, REGS, REGS)
resetmouserange

END SUB

DEFSNG A-Z
SUB mousehide
'   With A BIOS call INT33 AX = 2 it hides the mousecursor
'   Hiding the mouse is necessary when Building up a screen
'   When the screen is buildup MOUSESHOW must be called to turn on Mouse again
'----------------------------------------------------------------------------

	REGS.AX = 2
	CALL INTERRUPTX(&H33, REGS, REGS)
END SUB

SUB mouseput (x%, y%)
'  Action: Puts the mousecursor at the specific X and Y position
'-----------------------------------------------------------

	REGS.AX = &H4
	REGS.cx = x%
	REGS.dx = y%
	CALL INTERRUPTX(&H33, REGS, REGS)
END SUB

SUB mouseshow
'   Action: Displays the mousecursor SUB must be used in a LOOP
'------------------------------------------------------

	REGS.AX = 1
	CALL INTERRUPTX(&H33, REGS, REGS)
END SUB

DEFINT A-Z
SUB mousestatus (lb, rb, x, y)
'   Action: checks the Mousestatus (Coordinates and button status)

'   SUB returns in:
'---------------------------------------------------------------
'   X% = Current X position of Mousecursor
'   Y% = Current Y postions of Mousecursor
'   BUTTON% = Button status (BUTTON% = 0: No button pressed)
'                           (BUTTON% = 1: Left button pressed)
'                           (BUTTON% = 2: Right button pressed)
'--------------------------------------------------------------
   
	REGS.AX = 3
	CALL INTERRUPTX(&H33, REGS, REGS)
	button% = REGS.bx
	IF button% = 1 THEN
	lb = -1
	ELSEIF button% = 2 THEN
	rb = -1
	ELSE
	lb% = 0
	rb% = 0
	END IF
	x% = REGS.cx
	y% = REGS.dx
END SUB

DEFSNG A-Z
SUB resetmouserange
' Action: Resets the mouserange to the default values

REGS.AX = &H7
REGS.bx = &H0
REGS.cx = 0
REGS.dx = 639
CALL INTERRUPTX(&H33, REGS, REGS)

REGS.AX = &H8
REGS.bx = &H0
REGS.cx = 0
REGS.dx = 479
CALL INTERRUPTX(&H33, REGS, REGS)
END SUB

SUB setmouserange (x%, y%, X2%, Y2%)
'   Action: Sets the mouse range (range where mouse can be moved)

'   With parameters can range be modified
'   X% = Upper LEFT, X2% = Upper right coordinate
'   Y% = Lower Left, Y2% = Lower right coordinate
'-----------------------------------------------------------------------

	REGS.AX = &H7
	REGS.bx = &H0
	REGS.cx = x%
	REGS.dx = X2%
	CALL INTERRUPTX(&H33, REGS, REGS)

	REGS.AX = &H8
	REGS.bx = &H0
	REGS.cx = y%
	REGS.dx = Y2%
	CALL INTERRUPTX(&H33, REGS, REGS)

END SUB

SUB textcursor
' Makes a screen and cursor mask and changes the mousecursor with a BIOS call
' This text cursor can be used for Textfields
DIM CURSOR%(0 TO 15, 0 TO 1)

'     SCREEN MASK
	  FOR i% = 0 TO 15
		  CURSOR%(i%, 0) = &HFFFF
	  NEXT

	' Define the cursor% mask
	  CURSOR%(0, 1) = &HFE0          '0000111111100000
	  CURSOR%(1, 1) = &H100          '0000000100000000
	  CURSOR%(2, 1) = &H100          '0000000100000000
	  CURSOR%(3, 1) = &H100          '0000000100000000
	  CURSOR%(4, 1) = &H100          '0000000100000000
	  CURSOR%(5, 1) = &H100          '0000000100000000
	  CURSOR%(6, 1) = &H100          '0000000100000000
	  CURSOR%(7, 1) = &H100          '0000000100000000
	  CURSOR%(8, 1) = &H100          '0000000100000000
	  CURSOR%(9, 1) = &H100          '0000000100000000
	  CURSOR%(10, 1) = &H100         '0000000100000000
	  CURSOR%(11, 1) = &H100         '0000000100000000
	  CURSOR%(12, 1) = &H100         '0000000100000000
	  CURSOR%(13, 1) = &HFE0         '0001111111100000
	  CURSOR%(14, 1) = &H0           '0000000000000000
	  CURSOR%(15, 1) = &H0           '0000000000000000

REGS.AX = &H9
REGS.bx = 0
REGS.cx = 0
REGS.es = VARSEG(CURSOR%(0, 0))
REGS.dx = VARPTR(CURSOR%(0, 0))
CALL INTERRUPTX(&H33, REGS, REGS)
resetmouserange
END SUB

